#!/bin/bash

if [ $# -ne 1 ]; then
    echo "USAGE: $0 taxonName" >&2
    exit 1
fi

home=$(dirname $0)
. $home/locale.sh

taxon="$1"

if ! cd $targetDir; then
    exit 1
fi

taxonPath=$(find $targetDir -maxdepth 4 -type d -name "$taxon")
n=$(echo "$taxonPath"|wc -w)
if [ $n -lt 1 ]; then
    echo "taxon \"$taxon\" not found" >&2
    exit 1
elif [ $n -gt 1 ]; then
    echo "ambigous taxon \"$taxon\"" >&2
    exit 1
fi

echo publishing: "$taxonPath"

cd $taxonPath
cd ..
targetPath=$(dirname "$taxonPath")
baseTaxon=$(basename "$targetPath")
targetPath=${targetPath#$targetDir}
parentThumb="$taxon.jpg"
parentHtml="$baseTaxon.html"

if [ "$taxon" == "diptera" ]; then
    parentThumb=""
    parentHtml=""
elif ! [ -f "$taxon.jpg" ]; then
    echo missing thumbnail "$(pwd)/$taxon.jpg" >&2
    exit 1
elif ! [ -f "$baseTaxon.html" ]; then
    echo missing html for base taxon "$(pwd)/$baseTaxon.html" >&2
    exit 1
fi
echo in $(pwd)

echo rsync -a --delete "$taxon" "$parentThumb" "$parentHtml" $serverUrl/$targetPath
rsync -a --delete "$taxon" "$parentThumb" "$parentHtml" $serverUrl/$targetPath
