#!/bin/bash

home=$(dirname $0)
. $home/locale.sh

if [ "${1#$origDir}" != "$1" ]; then
    . $home/gimpFuncs.sh
    dir=$(dirname $1)

    if ! [ -r $state ]; then
	if ! gimpLoadSpecimen $dir; then
	    echo "ERROR: failed to load files of \"$dir\"" >&2
	    read
	    exit 1
	else
	    echo -n "loaded" >$state
	fi
    else
	if ! [ -r $displays ]; then
	    rm $state
	    echo "ERROR: missing file \"$displays\"" >&2
	    read
	    exit
	fi
	gimpWebbifySpecimen $dir
	base=$(basename $dir)
	if [ "${base/_}" != "$base" ]; then
	    cd 
	    $home/webbifyHtml.sh ${dir#$usrHome/}
	fi
	gimpCmds "$(gimpCmdCloseDisplays $(cat $displays))"
	rm $displays $state
    fi
elif [ "${1#$targetDir}" != "$1" ]; then
    base=$(basename "$1")
    if [ "${base#th_}" != "$base" ]; then
	thumb="$1"
    elif [ "${base%.jpg}" != "$base" ]; then
	thumb="$1"
    else
	thumb=$(dirname "$1")/th_"$base"
	if ! [ -r $tumb ]; then
	    echo "ERROR: need a thumbnail to promote"
	    read ans
	    exit 1
	fi
    fi

    dir=$(dirname "$thumb")
    parent=$(basename "$dir")
    targDir=$(dirname "$dir")
    cp "$thumb" "$targDir/$parent.jpg"
    
    if [ "$webbifyCreateHtml" == "y" ]; then
	if [ -z "${parent//[0-9]}" ]; then
	    parent=$(basename "$targDir")
	fi
	if ! $home/webbifyHtml.sh "$parent" >&2; then
	    read ans
	    exit 1
	fi
	if [ "$webbifyPublish" == "y" ]; then
	    if ! $home/publishTaxon.sh "$parent" >&2; then
		read ans
	    fi
	fi
    fi
else
    echo "ERROR: unknown directory, must be $origDir or $targetDir" >&2
    read ans
fi
