getDateOfImg () {
    local name=$1
    local img=$2

    line=($(grep $img $infoFile))
    if [ "$name" == "${line[5]}" ]; then
	printf "%s" "${line[0]} ${line[1]}"
    fi
}

getSpecimenInfo(){
    gawk -v "htmlDir=$1" -v "places=$placesFile" -f $binDir/getSpecimenInfo.awk $infoFile
}

checkSpecimenInfo(){
    local htmlDir="$1"
    local id="$2"
    local cond="$3"
    local name dir

    if [ -z "$id" ]; then
	name=$(basename "$htmlDir")
	if [ -z "${name//[0-9]}" ]; then
	    dir=$(dirname "$htmlDir")
	    name=$(basename "$dir")/"$name"
	fi
	echo "ERROR: missing specimen id in \"$name\"" >&2
    elif [ "${id:0:1}" != "-" ]; then
	if [ "${id:0:1}" == "(" ]; then
	    id="${id#(}";
	    info[0]="${id%)}";
	    echo "newId: ${info[0]}" >&2
	fi
	if [ -z "$cond" ]; then
	    name=$(basename "$htmlDir")
	    if [ -z "${name//[0-9]}" ]; then
		dir=$(dirname "$htmlDir")
		name=$(basename "$dir")/"$name"
	    fi
	    echo "ERROR: missing condition in \"$name\"" >&2
	fi
    fi
}

getCondOfSpecimen () {
    local date="$1"
    local no="$2"
    gawk -v "date=$date" -v "no=$no" -v "places=$places" -f $binDir/condOfSpecimen.awk
}

mkSpecimenInfo () {
    local htmlDir="$1"
    local -a info=($(getSpecimenInfo "$htmlDir"))
    local i
    #echo checkSpecimenInfo "$htmlDir" "${info[0]}" "${info[4]}" >&2
    #echo "info: ${info[0]} / ${info[1]} /  ${info[2]} /  ${info[3]} / ${info[4]}" >&2
    checkSpecimenInfo "$htmlDir" "${info[0]}" "${info[4]}"
    echo "<table style=\" text-align: left; width: 912px; background-color:"
    echo "rgb(192, 192, 192);\" border=\"1\" cellpadding=\"2\" cellspacing=\"2\">"
    echo "<caption>Specimen Info:<br>"
    echo "</caption> <tbody>"
    echo "<tr>"
    echo "<td style=\"text-align: center; vertical-align: middle; width:"
    echo "10%;\">Id<br>"
    echo "</td>"
    echo "<td style=\"text-align: center; vertical-align: middle; width:"
    echo "30%;\">Time<br>"
    echo "</td>"
    echo "<td style=\"text-align: center; vertical-align: middle; width:"
    echo "30%;\">Place<br>"
    echo "</td>"
    echo "<td style=\"text-align: center; vertical-align: middle;\">Conditions<br>"
    echo "</td>"
    echo "</tr>"
    echo "<tr>"
    if [ ${#info[*]} -gt 0 ]; then
	echo "<td style=\"text-align: center; vertical-align: middle;\">${info[0]%\(*}<br></td>"
	echo "<td style=\"text-align: center; vertical-align: middle;\">${info[1]} ${info[2]}<br></td>"
	echo "<td style=\"text-align: center; vertical-align: middle;\">${info[3]}<br></td>"
	printf "<td style=\" text-align: center; vertical-align: middle;\">"
	i=4;
	while [ $i -lt ${#info[*]} ]; do
	    printf "%s " ${info[$i]}
	    i=$(($i+1))
	done
	printf "<br></td>\n"
    else
	echo "<td style=\"text-align: center; vertical-align: middle;\"><br></td>"
	echo "<td style=\"text-align: center; vertical-align: middle;\"><br></td>"
	echo "<td style=\"text-align: center; vertical-align: middle;\"><br></td>"
	echo "<td style=\"text-align: center; vertical-align: middle;\"><br></td>"
    fi
    echo "</tbody>"
    echo "</table>"
}

mkUpHrefs () {
    local htmlFile="$1"
    local i n p writtenName
    local path=$(dirname $(dirname $htmlFile))

    path=${path#$targetDir}
    path=${path#/}
    path=(${path//\// })
    n=${#path[*]}
    i=0
    while [ $i -lt $n ]; do
	printf "%s" "    <a href=\"" >>$htmlFile
	j=0
	while [ $j -lt $(($n-$i)) ]; do
	    printf "%s" "../" >>$htmlFile
	    j=$(($j+1))
	done
	printf "%s" "${path[$i]}.html" >>$htmlFile
	writtenName=${path[$i]}
	writtenName=${writtenName//_/ }
	writtenName=${writtenName//0/#}
	writtenName=${writtenName^[a-z]}

	printf "%s" "\">${writtenName}</a> >" >>$htmlFile
	i=$(($i+1))
    done
}

mkImgUpHrefs () {
    local name="$1"
    local htmlFile="$2"
    local i n p writtenName
    local path=$(dirname $htmlFile)
    path=${path#$targetDir}
    path=${path#/}
    path=(${path//\// })

    n=${#path[*]}
    i=0
    while [ $i -lt $n ]; do
	printf "%s" "    <a href=\"" >>$htmlFile
	j=0
	while [ $j -lt $(($n-$i)) ]; do
	    printf "%s" "../" >>$htmlFile
	    j=$(($j+1))
	done
	printf "%s" "${path[$i]}/${path[$i]}.html" >>$htmlFile
	if [ $i -eq $(($n-1)) ]; then
	    writtenName=$name
	else
	    writtenName=${path[$i]}
	fi
	writtenName=${writtenName//_/ }
	writtenName=${writtenName//0/#}
	writtenName=${writtenName^[a-z]}
	p=${p^[a-z]}
	printf "%s" "\">${writtenName}</a> >" >>$htmlFile
	i=$(($i+1))
    done
}

mkUpPath () {
    local htmlFile="$1"
    local i n p
    local path=$(dirname $(dirname $htmlFile))
    path=${path#$targetDir}
    path=${path#/}
    path=(${path//\// })

    n=${#path[*]}
    i=0
    printf "%s" "    <p>" >>$htmlFile
    while [ $i -lt $n ]; do
	p=${path[$i]}
	p=${p^[a-z]}
	printf "%s" "${p} > " >>$htmlFile
	i=$(($i+1))
    done
    printf "%s" "</p>" >>$htmlFile
}

mkTableHeader () {
    local tableWidth="$1"
    echo "    <table style=\" text-align: center; width: ${tableWidth}px; background-color:"
    echo "      rgb(0, 0, 0);\" border=\"0\""
    echo "      cellpadding=\"0\" cellspacing=\"2\">"
    echo "      <tbody>"
}

mkEmptyTd () {
    echo "          <td style=\"background-color: rgb(255, 255, 255);\"><br>"
    echo "          </td>"
}

mkTdImg () {
    local imgFile="$1"
    local thumbFile="$2"
    local htmlDir="$3"

    echo "          <td style=\"vertical-align: middle; horizontal-align: center; background-color: rgb(255, 255, 255); width: 300px; height: 200px;\">"
    echo "            <a href=\"${imgFile%.JPG}.html\">"
    echo "              <img alt=\"\" src=\"${thumbFile}\" style=\"border: 0px solid;"
    if imageTooHigh $htmlDir/$thumbFile; then 
	echo "                height: 200px;\"></a><br>"
    else
	echo "                width: 300px;\"></a><br>"
    fi
    echo "          </td>"
}

mkTdImgText(){
    local linkFile="$1"
    local thumbFile="$2"
    local htmlDir="$3"
    local writtenName="$4"
    
    echo "          <td style=\"vertical-align: top; background-color: rgb(255,"
    echo "            255, 255);\"> <a "
    echo "              href=\"${linkFile}\"><img"
    echo "                alt=\"${writtenName}\" title=\"${writtenName}\""
    echo "                src=\"${thumbFile}\" style=\"border: 2px solid;"
    if imageTooHigh $htmlDir/$thumbFile; then 
        echo "                border: 0px solid; height: 200px;\"></a><br><a"
	
    else
        echo "                border: 0px solid; width: 300px;\"></a><br><a"
	fi
    echo "              href=\"${linkFile}\">"
    echo "              ${writtenName}</a> </td>"
    
}


mkSpeciesHtml () {
    local name="$1"
    local base
    local htmlFile="$2"
    local imgFile thumbFile i n file files tableWidth firstJpgFile prevPhoto nextFoto
    local -a fileArr
    local imgsPerRow=3
    local htmlDir=$(dirname $htmlFile)
    local writtenName=${name//_/ }
    writtenName=${writtenName//0/#}
    writtenName=${writtenName^[a-z]}

    n=0
    for file in $htmlDir/*.JPG; do
	if [ "$file" == "$htmlDir/*.JPG" ]; then
	    echo "ERROR: empty dir \"$htmlDir\""
	    return
	fi
	base=$(basename $file)
	if [ "$base" != "${base#th_}" ]; then
	    continue
	fi
	n=$(($n+1))
	files="$files $file"
	if [ -z "$firstJpgFile" ]; then
	    firstJpgFile=$(basename $file)
	fi
    done
    fileArr=($files)
    if [ $n -eq 1 ]; then
	tableWidth=304
    elif [ $n -eq 2 ]; then
	tableWidth=608
    else
	tableWidth=912
    fi

    echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">" >$htmlFile
    echo "<html>" >>$htmlFile
    echo "  <head>" >>$htmlFile
    echo "    <meta content=\"text/html; charset=UTF-8\"" >>$htmlFile
    echo "      http-equiv=\"Content-Type\">" >>$htmlFile
    echo "    <title>${writtenName}</title>" >>$htmlFile
    echo "  </head>" >>$htmlFile
    echo "  <body bgcolor=\"#dddddd\">" >>$htmlFile
    mkUpHrefs "$htmlFile"
    echo "    <h3 style=\"text-align: center;\">${writtenName}</title></h3>" >>$htmlFile
    mkTableHeader $tableWidth >>$htmlFile
    i=0
    for file in $files; do
	imgFile=$(basename $file)
	thumbFile=th_$imgFile
	if [ $(($i % $imgsPerRow)) -eq 0 ]; then
	    echo "        <tr>" >>$htmlFile
	fi
	mkTdImg "$imgFile" "$thumbFile" "$htmlDir" >>$htmlFile
	i=$(($i+1))
	if [ $(($i % $imgsPerRow)) -eq 0 ]; then
	    echo "        </tr>" >>$htmlFile
	fi
	if [ $i -gt 1 ]; then
	    prevPhoto=$(basename ${fileArr[$(($i-2))]})
	    prevPhoto=${prevPhoto%.JPG}.html
	else
	    prevPhoto=""
	fi
	if [ $i -lt $n ]; then
	    nextPhoto=$(basename ${fileArr[$i]})
	    nextPhoto=${nextPhoto%.JPG}.html
	else
	    nextPhoto=""
	fi
	mkImgHtml $name $imgFile $(dirname $htmlFile) "$prevPhoto" "$nextPhoto"

    done
    if [ $n -gt 2 ]; then
	while [ $(($i % $imgsPerRow)) -ne 0 ]; do
	    mkEmptyTd >>$htmlFile
	    i=$(($i+1))
	done
    fi
    echo "        <tr>" >>$htmlFile
    echo "      </tbody>" >>$htmlFile
    echo "    </table>" >>$htmlFile
    echo "    <p>" >>$htmlFile
    echo "    </p>" >>$htmlFile
    if [ -n "$firstJpgFile" ]; then
	mkSpecimenInfo "$htmlDir" >>$htmlFile
    fi

    n=0
    files=""
    for file in $(find $htmlDir -maxdepth 1 -type d|sort -n); do
	if [ $file == $htmlDir -o "${file#.}" != "$file" ]; then
	    continue
	fi
	n=$(($n+1))
	files="$files $file"
    done
    if [ $n -eq 1 ]; then
	tableWidth=304
    elif [ $n -eq 2 ]; then
	tableWidth=608
    else
	tableWidth=912
    fi
    if [ $n -gt 0 ]; then
	echo "    <br>" >>$htmlFile
	echo "    <br>" >>$htmlFile
	echo "    Other specimens:<br>" >>$htmlFile
	echo "    <br>" >>$htmlFile
	mkTableHeader $tableWidth >>$htmlFile

	i=0
	for file in $files; do
	    base=$(basename $file)
	    linkFile=$base/$base.html
	    thumbFile=$base.jpg
	    if ! [ -f "$htmlDir/$base.jpg" ]; then
		echo "WARN: missing thumbnail for \"$(basename $(dirname $htmlFile))/${base}\"" >&2
	    fi

	    mkSpeciesHtml ${name}_#$(($i+2)) $file/$base.html

	    if [ $(($i % $imgsPerRow)) -eq 0 ]; then
		echo "        <tr>" >>$htmlFile
	    fi
	    mkTdImg "${linkFile%.html}.JPG" $thumbFile $htmlDir >>$htmlFile
	    i=$(($i+1))
	    if [ $(($i % $imgsPerRow)) -eq 0 ]; then
		echo "        </tr>" >>$htmlFile
	    fi
	done
	if [ $n -gt 2 ]; then
	    while [ $(($i % $imgsPerRow)) -ne 0 ]; do
		mkEmptyTd >>$htmlFile
		i=$(($i+1))
	    done
	fi
	echo "        <tr>" >>$htmlFile
	echo "      </tbody>" >>$htmlFile
	echo "    </table>" >>$htmlFile
	echo "    <p><br>" >>$htmlFile
	echo "    </p>" >>$htmlFile
    fi

    echo "  </body>" >>$htmlFile
    echo "</html>" >>$htmlFile
}

mkNonSpeciesHtml () {
    local name="$1"
    local dir="$2"
    local htmlFile=$dir/$name.html
    local imgFile thumbFile subDir subDirs i n tableWidth
    local imgsPerRow=3
    local writtenName=${name//_/ }
    writtenName=${writtenName//0/#}
    writtenName=${writtenName^[a-z]}
    n=0
    for subDir in $(find $dir -maxdepth 1 -type d|sort); do
	base=$(basename $subDir)
	if [ "${base#.}" != "$base" ]; then
	    continue
	fi
	if [ "$subDir" == "$dir" -o "${base#[0-9]}" != "$base" ]; then
	    continue
	fi
	subDirs="$subDirs $subDir"
	n=$(($n+1))
    done

    if [ $n -eq 1 ]; then
	tableWidth=304
    elif [ $n -eq 2 ]; then
	tableWidth=608
    else
	tableWidth=912
    fi

    echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">" >$htmlFile
    echo "<html>" >>$htmlFile
    echo "  <head>" >>$htmlFile
    echo "    <meta content=\"text/html; charset=UTF-8\"" >>$htmlFile
    echo "      http-equiv=\"Content-Type\">" >>$htmlFile
    echo "    <title>${writtenName}</title>" >>$htmlFile
    echo "  </head>" >>$htmlFile
    echo "  <body bgcolor=\"#dddddd\">" >>$htmlFile
    mkUpHrefs $htmlFile
    echo "    <h3 style=\"text-align: center;\">${writtenName}<br>" >>$htmlFile
    echo "    </h3>" >>$htmlFile
    mkTableHeader $tableWidth >>$htmlFile

    i=0
    for subDir in $subDirs; do
	if [ -z "$(ls $subDir)" ]; then
	    continue
	fi
	name=$(basename $subDir)
	if [ "${name#[0-9]}" != "$name" ]; then
	    continue
	elif [ "$name" == "uncertain" ]; then
	    continue
	fi
	thumbFile=$name.jpg
	linkFile=$name/$name.html
	writtenName=${name//_/ }
	writtenName=${writtenName//0/#}
	writtenName=${writtenName^[a-z]}

	if [ $(($i % $imgsPerRow)) -eq 0 ]; then
	    echo "        <tr>" >>$htmlFile
	fi
	mkTdImgText $linkFile $thumbFile $dir "$writtenName" >>$htmlFile

	i=$(($i+1))
	if [ $(($i % $imgsPerRow)) -eq 0 ]; then
	    echo "        </tr>" >>$htmlFile
	fi
    done
    if [ $n -gt 2 ]; then
	while [ $(($i % $imgsPerRow)) -ne 0 ]; do
            echo "          <td style=\"vertical-align: top; background-color: rgb(255," >>$htmlFile
            echo "            255, 255);\">" >>$htmlFile
	    echo "          </td>" >>$htmlFile
	    i=$(($i+1))
	done
    fi

    echo "      </tbody>" >>$htmlFile
    echo "    </table>" >>$htmlFile
    echo "  </body>" >>$htmlFile
    echo "</html>" >>$htmlFile

}

mkImgHtml () {
    local name="$1"
    local base
    local imgFile="$2"
    local htmlPath="$3"
    local prev="$4"
    local next="$5"
    local htmlFile="$htmlPath/${imgFile%.JPG}.html"
    local thumbFile i n file
    local imgsPerRow=3
    local htmlDir=$(dirname $htmlFile)
    local writtenName=${name//_/ }
    writtenName=${writtenName//0/#}
    writtenName=${writtenName^[a-z]}

    echo "<!DOCTYPE html PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">" >$htmlFile
    echo "<html>" >>$htmlFile
    echo "  <head>" >>$htmlFile
    echo "    <meta content=\"text/html; charset=UTF-8\"" >>$htmlFile
    echo "      http-equiv=\"Content-Type\">" >>$htmlFile
    echo "    <title>${writtenName}</title>" >>$htmlFile
    echo "  </head>" >>$htmlFile
    echo "  <body bgcolor=\"#dddddd\">" >>$htmlFile
    echo "      <table style=\" text-align: left; width: 1200px;\" border=\"0\"" >>$htmlFile
    echo "        cellpadding=\"0\" cellspacing=\"0\">" >>$htmlFile
    echo "        <tbody>" >>$htmlFile
    echo "          <tr>" >>$htmlFile
    echo "            <td style=\" vertical-align: top;\">" >>$htmlFile
    mkImgUpHrefs $name $htmlFile
    echo "              </td>" >>$htmlFile
    if [ -n "$prev" ]; then
	echo "            <td style=\"text-align: right; vertical-align: top;\"><a href=\"$prev\" accesskey=\"p\">Prev Photo</a></td>" >>$htmlFile
    fi
    if [ -n "$next" ]; then
	echo "            <td style=\"text-align: right; vertical-align: top;\"><a href=\"$next\" accesskey=\"n\">Next Photo</a></td>" >>$htmlFile
    fi
    echo "          </tr>" >>$htmlFile
    echo "        </tbody>" >>$htmlFile
    echo "      </table>" >>$htmlFile


    echo "  <p><img  alt=\"\" src=\"${imgFile}\"></p>" >>$htmlFile
    echo "  </body>" >>$htmlFile
    echo "</html>" >>$htmlFile
}

calc () {
    local expr="$1"
    bc <<EOF
scale=12
$expr
quit
EOF
}

imageHeigthWidthRatio(){
   local img="$1"
   local hw=($(identify -format "%h %w" $img))

   calc "${hw[0]}/${hw[1]}"
}

imageTooHigh () {
    local img="$1"
    if ! [ -r $img ]; then
	echo "ERROR: missing image \"$img\"" >&2
	return 1
    fi

    local hw=($(identify -format "%h %w" $img))

    if [ $(calc "${hw[0]}/${hw[1]} <= .6666666667") == "1" ]; then
	return 1
    else
	return 0
    fi
}

scaleImg () {
    local img="$1"
    local width="$2"
    local height="$3"
    local quality="$4"
    local target="$5"

    if imageTooHigh $img; then
	convert "$img" -scale x$height -quality $quality  "$target"
    else
        convert "$img" -scale $width -quality $quality  "$target"
    fi
}

